﻿namespace Gra
{
    public class Plansza
    {
        private readonly Komórka [,] _komórki;

        public Plansza(int szerokość, int wysokość)
        {
            _komórki = new Komórka[szerokość, wysokość];
            for (int i = 0; i < szerokość; i++)
            {
                for (int j = 0; j < wysokość; j++)
                {
                    _komórki[i, j] = new Komórka();
                }
            }
            Szerokość = szerokość;
            Wysokość = wysokość;
        }

        public Plansza()
            : this(20, 20)
        { 
            
        }

        public int Szerokość { get; private set; }
        public int Wysokość { get; private set;  }

        public Komórka DajKomórkę(int i, int j)
        {
            return _komórki[i, j];
        }

        public int IleSąsiadów(int i, int j)
        {
            int ls = 0;
            
            if (_komórki[(i + Szerokość - 1)%Szerokość, (j + Wysokość - 1) % Wysokość].CzyŻywa) ls++;
            if (_komórki[(i + Szerokość - 1) % Szerokość, (j + Wysokość) % Wysokość].CzyŻywa) ls++;
            if (_komórki[(i + Szerokość - 1) % Szerokość, (j + Wysokość + 1) % Wysokość].CzyŻywa) ls++;
            if (_komórki[(i + Szerokość) % Szerokość, (j + Wysokość - 1) % Wysokość].CzyŻywa) ls++;
            if (_komórki[(i + Szerokość) % Szerokość, (j + Wysokość + 1) % Wysokość].CzyŻywa) ls++;
            if (_komórki[(i + Szerokość + 1) % Szerokość, (j + Wysokość - 1) % Wysokość].CzyŻywa) ls++;
            if (_komórki[(i + Szerokość + 1) % Szerokość, (j + Wysokość) % Wysokość].CzyŻywa) ls++;
            if (_komórki[(i + Szerokość + 1) % Szerokość, (j + Wysokość + 1) % Wysokość].CzyŻywa) ls++;

            return ls;
        }


    }
}
