﻿using System;
using System.Threading;

namespace Gra
{
    class Program
    {
        static void Main(string[] args)
        {
            if (args == null) throw new ArgumentNullException("args");
            int szerokosc, wysokość;
            double prawdopodobienstwo;

            Console.Clear();
            Console.Write("Szerokosc planszy [domyślnie 10] = ");
            if (int.TryParse(Console.ReadLine(), out szerokosc) == false) szerokosc = 10;

            Console.Write("Wysokość   planszy [domyślnie 10] = ");
            if (int.TryParse(Console.ReadLine(), out wysokość) == false) wysokość = 10;

            Console.Write("prawdopodobienstwo [domyślnie 0.25] = ");
            if (double.TryParse(Console.ReadLine(), out prawdopodobienstwo) == false) prawdopodobienstwo = 0.25;
            if (prawdopodobienstwo < 0 || prawdopodobienstwo > 1) prawdopodobienstwo = 0.25;
            Console.CursorVisible = false;
          
            
            Gra gra = new Gra(new Plansza(szerokosc, wysokość));
            gra.Inicjij(prawdopodobienstwo);
            
            while (true)
            {
                gra.Rysuj();
                
                if (Console.KeyAvailable)
                {
                    ConsoleKeyInfo cki = Console.ReadKey(true);
                    if (cki.Key == ConsoleKey.Spacebar) break;
                    gra.Znak = cki.KeyChar;
                }
                
                gra.Cykkl();
                
                Thread.Sleep(1000);
            }

            string nazwapliku = "life.txt";
            Console.CursorVisible = true;
            Console.Write("Podaj nazw pliku do zapisu [domyślnie life.txt] ");
            string nazwa = Console.ReadLine();
            if (!string.IsNullOrEmpty(nazwa)) nazwapliku = nazwa;
            if (gra.Zapisz(nazwapliku))
                Console.WriteLine("Ok. Zapisany ostatni stan");
            else
                Console.WriteLine("Blad zapisu!");
        }
    }
}
